> For the complete documentation index, see [llms.txt](https://docs.yarnspinner.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yarnspinner.dev/api/csharp/yarn.unity/yarn.unity.yarnproject.md).

# YarnProject

Class in [Yarn.Unity](/api/csharp/yarn.unity.md)

Inherits from `UnityEngine.ScriptableObject`

## Summary

```csharp
public sealed class YarnProject : ScriptableObject
```

## Classes

| Name                                                                                                                   | Description |
| ---------------------------------------------------------------------------------------------------------------------- | ----------- |
| [ShadowTableDictionary](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.shadowtabledictionary.md) |             |

## Fields

| Name                                                                                                               | Description |
| ------------------------------------------------------------------------------------------------------------------ | ----------- |
| [baseLocalization](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.baselocalization.md)       |             |
| [compiledYarnProgram](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.compiledyarnprogram.md) |             |
| [lineMetadata](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.linemetadata.md)               |             |
| [localizations](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.localizations.md)             |             |
| [localizationType](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.localizationtype.md)       |             |

## Methods

| Name                                                                                                                          | Description                                                          |
| ----------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------- |
| [GetHeaders(string)](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.getheaders.md)                      | Gets the headers for the requested node.                             |
| [GetLineIDsForNodes(IEnumerable)](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.getlineidsfornodes.md) | Returns a list of all line and option IDs within the requested nodes |
| [GetLocalization(string)](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.getlocalization.md)            | Gets a Localization given a locale code.                             |

## Properties

| Name                                                                                                   | Description                                                                                                                                                                                                        |
| ------------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| [InitialValues](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.initialvalues.md) | The default values of all declared or inferred variables in the [Program](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.program.md) . Organised by their name as written in the yarn files. |
| [NodeNames](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.nodenames.md)         | The names of all nodes contained within the [Program](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.program.md) .                                                                           |
| [Program](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.program.md)             | Gets the Yarn Program stored in this project.                                                                                                                                                                      |

## Structs

| Name                                                                                                         | Description |
| ------------------------------------------------------------------------------------------------------------ | ----------- |
| [ShadowTableEntry](/api/csharp/yarn.unity/yarn.unity.yarnproject/yarn.unity.yarnproject.shadowtableentry.md) |             |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yarnspinner.dev/api/csharp/yarn.unity/yarn.unity.yarnproject.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
